]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
cdrom+flash-image: Move all temporary files to /tmp
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06fc566a 20# Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
2f767b7b 28VERSION="2.25" # Version number
e6c2265d 29CORE="143" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
32NICE=10 # Nice level
33MAX_RETRIES=1 # prefetch/check loop
305a7b38 34BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 35KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
36
37# Information from Git
38GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
39GIT_TAG="$(git tag | tail -1)" # Git Tag
40GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 41
2f767b7b 42TOOLCHAINVER=20200108
03ad5f93 43
69a6ec55
MT
44###############################################################################
45#
46# Beautifying variables & presentation & input output interface
47#
48###############################################################################
49
f9783277
MT
50# Remember if the shell is interactive or not
51if [ -t 0 ] && [ -t 1 ]; then
52 INTERACTIVE=true
53else
54 INTERACTIVE=false
55fi
56
401a1edc
MT
57# Sets or adjusts pretty formatting variables
58resize_terminal() {
59 ## Screen Dimentions
60 # Find current screen size
61 COLUMNS=$(tput cols)
62
63 # When using remote connections, such as a serial port, stty size returns 0
64 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
65 COLUMNS=80
66 fi
69a6ec55 67
401a1edc
MT
68 # Measurements for positioning result messages
69 OPTIONS_WIDTH=20
70 TIME_WIDTH=12
71 STATUS_WIDTH=8
72 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
73 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
74
e9a57acd
MT
75 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
76 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 77}
69a6ec55 78
401a1edc
MT
79# Initially setup terminal
80resize_terminal
f9783277 81
401a1edc
MT
82# Call resize_terminal when terminal is being resized
83trap "resize_terminal" WINCH
69a6ec55
MT
84
85# Define color for messages
86BOLD="\\033[1;39m"
87DONE="\\033[1;32m"
88SKIP="\\033[1;34m"
89WARN="\\033[1;35m"
90FAIL="\\033[1;31m"
91NORMAL="\\033[0;39m"
92
bcb9dc13 93# New architecture variables
dc7d6b20 94HOST_ARCH="$(uname -m)"
94571564 95
69a6ec55
MT
96PWD=$(pwd)
97BASENAME=$(basename $0)
98
15679d9f
MT
99# Debian specific settings
100if [ ! -e /etc/debian_version ]; then
df5e82b3 101 FULLPATH=`which $0`
15679d9f 102else
df5e82b3
MT
103 if [ -x /usr/bin/realpath ]; then
104 FULLPATH=`/usr/bin/realpath $0`
105 else
106 echo "ERROR: Need to do apt-get install realpath"
107 exit 1
108 fi
15679d9f 109fi
df5e82b3 110
69a6ec55 111# This is the directory where make.sh is in
aecbe123 112export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 113
ebaecf2c
AF
114LOGFILE=$BASEDIR/log/_build.preparation.log
115export LOGFILE
15679d9f 116DIR_CHK=$BASEDIR/cache/check
ebaecf2c 117mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 118
69a6ec55
MT
119system_processors() {
120 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
121}
122
123system_memory() {
124 local key val unit
125
126 while read -r key val unit; do
127 case "${key}" in
128 MemTotal:*)
129 # Convert to MB
130 echo "$(( ${val} / 1024 ))"
131 break
132 ;;
133 esac
134 done < /proc/meminfo
135}
136
137configure_build() {
138 local build_arch="${1}"
139
140 if [ "${build_arch}" = "default" ]; then
141 build_arch="$(configure_build_guess)"
142 fi
143
144 case "${build_arch}" in
145 x86_64)
146 BUILDTARGET="${build_arch}-unknown-linux-gnu"
147 CROSSTARGET="${build_arch}-cross-linux-gnu"
148 BUILD_PLATFORM="x86"
7520b95a 149 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
69a6ec55
MT
150 ;;
151
152 i586)
153 BUILDTARGET="${build_arch}-pc-linux-gnu"
154 CROSSTARGET="${build_arch}-cross-linux-gnu"
155 BUILD_PLATFORM="x86"
7520b95a 156 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
157 ;;
158
159 aarch64)
160 BUILDTARGET="${build_arch}-unknown-linux-gnu"
161 CROSSTARGET="${build_arch}-cross-linux-gnu"
162 BUILD_PLATFORM="arm"
840f0b9f 163 CFLAGS_ARCH=""
69a6ec55
MT
164 ;;
165
166 armv7hl)
167 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
168 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
169 BUILD_PLATFORM="arm"
170 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
171 ;;
172
173 armv5tel)
174 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
175 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
176 BUILD_PLATFORM="arm"
177 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
82454983 178 RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
179 ;;
180
181 *)
182 exiterror "Cannot build for architure ${build_arch}"
183 ;;
184 esac
185
186 # Check if the QEMU helper is available if needed.
187 if qemu_is_required "${build_arch}"; then
188 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
189
190 if [ -n "${qemu_build_helper}" ]; then
191 QEMU_TARGET_HELPER="${qemu_build_helper}"
192 else
193 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
194 fi
195 fi
196
197 BUILD_ARCH="${build_arch}"
198 TOOLS_DIR="/tools_${BUILD_ARCH}"
199
200 # Enables hardening
54114eb0 201 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
202
203 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
204 CXXFLAGS="${CFLAGS}"
205
206 # Determine parallelism
eeee108f 207 # We assume that each process consumes about
297473d5 208 # 128MB of memory. Therefore we find out how
eeee108f 209 # many processes fit into memory.
297473d5 210 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
eeee108f
MT
211 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
69a6ec55 218 fi
212f17c1 219
eeee108f
MT
220 # Use this as default PARALLELISM
221 DEFAULT_PARALLELISM="${parallelism}"
222
212f17c1
MT
223 # Compression parameters
224 # We use mode 8 for reasonable memory usage when decompressing
225 # but with overall good compression
226 XZ_OPT="-8"
227
228 # We try to use as many cores as possible
229 XZ_OPT="${XZ_OPT} -T0"
230
231 # We need to limit memory because XZ uses too much when running
232 # in parallel and it isn't very smart in limiting itself.
233 # We allow XZ to use up to 70% of all system memory.
deffc275 234 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
235
236 # XZ memory cannot be larger than 2GB on 32 bit systems
237 case "${build_arch}" in
238 i*86|armv*)
239 if [ ${xz_memory} -gt 2048 ]; then
240 xz_memory=2048
241 fi
242 ;;
243 esac
244
245 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
246}
247
248configure_build_guess() {
249 case "${HOST_ARCH}" in
87487585
MT
250 x86_64)
251 echo "x86_64"
252 ;;
253 i?86)
69a6ec55
MT
254 echo "i586"
255 ;;
256
257 aarch64)
258 echo "aarch64"
259 ;;
260
261 armv7*|armv6*|armv5*)
262 echo "armv5tel"
263 ;;
264
265 *)
266 exiterror "Cannot guess build architecture"
267 ;;
268 esac
269}
270
f9783277
MT
271stdumount() {
272 umount $BASEDIR/build/sys 2>/dev/null;
273 umount $BASEDIR/build/dev/shm 2>/dev/null;
274 umount $BASEDIR/build/dev/pts 2>/dev/null;
275 umount $BASEDIR/build/dev 2>/dev/null;
276 umount $BASEDIR/build/proc 2>/dev/null;
277 umount $BASEDIR/build/install/mnt 2>/dev/null;
278 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
279 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/config 2>/dev/null;
281 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
282 umount $BASEDIR/build/usr/src/html 2>/dev/null;
283 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
284 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 285 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 286 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 287 umount $BASEDIR/build/usr/src 2>/dev/null;
f9783277
MT
288}
289
290now() {
291 date -u "+%s"
69a6ec55
MT
292}
293
f9783277
MT
294format_runtime() {
295 local seconds=${1}
296
297 if [ ${seconds} -ge 3600 ]; then
298 printf "%d:%02d:%02d\n" \
299 "$(( seconds / 3600 ))" \
300 "$(( seconds % 3600 / 60 ))" \
301 "$(( seconds % 3600 % 60 ))"
302 elif [ ${seconds} -ge 60 ]; then
303 printf "%d:%02d\n" \
304 "$(( seconds / 60 ))" \
305 "$(( seconds % 60 ))"
69a6ec55 306 else
f9783277 307 printf "%d\n" "${seconds}"
69a6ec55 308 fi
f9783277 309}
69a6ec55 310
f9783277
MT
311print_line() {
312 local line="$@"
69a6ec55 313
f9783277 314 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
315}
316
f9783277
MT
317_print_line() {
318 local status="${1}"
319 shift
69a6ec55 320
f9783277
MT
321 if ${INTERACTIVE}; then
322 printf "${!status}"
323 fi
69a6ec55 324
f9783277
MT
325 print_line "$@"
326
327 if ${INTERACTIVE}; then
328 printf "${NORMAL}"
329 fi
330}
331
332print_headline() {
333 _print_line BOLD "$@"
69a6ec55
MT
334}
335
f9783277
MT
336print_error() {
337 _print_line FAIL "$@"
338}
339
340print_package() {
341 local name="${1}"
342 shift
69a6ec55 343
f9783277
MT
344 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
345 local options="$@"
346
347 local string="${name}"
348 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
349 string="${string} (${version})"
350 fi
351
352 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 353 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
354}
355
356print_runtime() {
357 local runtime=$(format_runtime $@)
358
359 if ${INTERACTIVE}; then
360 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
361 else
362 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 363 fi
f9783277
MT
364}
365
366print_status() {
367 local status="${1}"
368
369 local color="${!status}"
370
371 if ${INTERACTIVE}; then
372 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
373 else
374 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 375 fi
f9783277 376}
69a6ec55 377
f9783277
MT
378print_build_stage() {
379 print_headline "$@"
380
381 # end line
382 printf "\n"
69a6ec55
MT
383}
384
f9783277
MT
385print_build_summary() {
386 local runtime=$(format_runtime $@)
387
388 print_line "*** Build finished in ${runtime}"
389 print_status DONE
69a6ec55
MT
390}
391
392exiterror() {
393 stdumount
394 for i in `seq 0 7`; do
395 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
396 losetup -d /dev/loop${i} 2>/dev/null
397 fi;
398 done
399
f9783277 400 # Dump logfile
66028310 401 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
402 echo # empty line
403
404 local line
405 while read -r line; do
406 echo " ${line}"
407 done <<< "$(tail -n30 ${LOGFILE})"
408 fi
409
f9783277
MT
410 echo # empty line
411
412 local line
413 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
414 print_error "${line}"
415 print_status FAIL
416 done
417
69a6ec55
MT
418 exit 1
419}
420
aecbe123
MT
421prepareenv() {
422 # Are we running the right shell?
54328605 423 if [ -z "${BASH}" ]; then
aecbe123
MT
424 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
425 fi
426
427 if [ -z "${BASH_VERSION}" ]; then
428 exiterror "Not running BASH shell."
429 fi
430
431 # Trap on emergency exit
432 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
433
434 # Resetting our nice level
658232a6 435 if ! renice ${NICE} $$ >/dev/null; then
658232a6 436 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
437 fi
438
439 # Checking if running as root user
658232a6 440 if [ $(id -u) -ne 0 ]; then
df7f30a1 441 exiterror "root privileges required for building"
aecbe123
MT
442 fi
443
444 # Checking for necessary temporary space
f9783277 445 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
446 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
447 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
448 if (( 2048000 > $BASE_ASPACE )); then
449 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
450 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 451 print_status FAIL
aecbe123
MT
452 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
453 fi
454 else
f9783277 455 print_status DONE
aecbe123
MT
456 fi
457
458 # Set umask
459 umask 022
460
461 # Set LFS Directory
462 LFS=$BASEDIR/build
463
aecbe123
MT
464 # Setup environment
465 set +h
466 LC_ALL=POSIX
82454983 467 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
aecbe123
MT
468 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
469
470 # Make some extra directories
471 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
472 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
473 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
3608d485 474 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
7c984de6
MT
475
476 if [ "${ENABLE_RAMDISK}" = "on" ]; then
477 mkdir -p $BASEDIR/build/usr/src
92fbca34 478 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
479
480 mkdir -p ${BASEDIR}/build/tmp
481 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
482 fi
483
ebaecf2c 484 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
485
486 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
487 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
488
489 # Make all sources and proc available under lfs build
490 mount --bind /dev $BASEDIR/build/dev
491 mount --bind /dev/pts $BASEDIR/build/dev/pts
492 mount --bind /dev/shm $BASEDIR/build/dev/shm
493 mount --bind /proc $BASEDIR/build/proc
494 mount --bind /sys $BASEDIR/build/sys
495 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
3608d485 496 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
aecbe123
MT
497 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
498 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
499 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
500 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
501 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 502 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
503 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
504
505 # Run LFS static binary creation scripts one by one
506 export CCACHE_DIR=$BASEDIR/ccache
507 export CCACHE_COMPRESS=1
508 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
509
510 # Remove pre-install list of installed files in case user erase some files before rebuild
511 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
512
513 # Prepare string for /etc/system-release.
f48643e5
MT
514 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
515
516 case "${GIT_BRANCH}" in
517 core*|beta?|rc?)
518 system_release="${system_release} - ${GIT_BRANCH}"
519 ;;
520 *)
9ff65bfa 521 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 522 ;;
aecbe123 523 esac
4e54a8e2 524
f48643e5
MT
525 # Append -dirty tag for local changes
526 if [ "$(git status -s | wc -l)" != "0" ]; then
527 system_release="${system_release}-dirty"
528 fi
529
530 # Export variable
531 SYSTEM_RELEASE="${system_release}"
532
040160c7
MT
533 # Decide on PAKFIRE_TREE
534 case "${GIT_BRANCH}" in
535 core*)
536 PAKFIRE_TREE="stable"
537 ;;
538 master)
539 PAKFIRE_TREE="testing"
540 ;;
541 *)
542 PAKFIRE_TREE="unstable"
543 ;;
544 esac
545
4e54a8e2
MT
546 # Setup ccache cache size
547 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
548}
549
69a6ec55
MT
550enterchroot() {
551 # Install QEMU helper, if needed
552 qemu_install_helper
553
554 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
555
556 PATH="${PATH}" chroot ${LFS} env -i \
557 HOME="/root" \
558 TERM="${TERM}" \
559 PS1="${PS1}" \
560 PATH="${PATH}" \
561 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 562 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
563 NAME="${NAME}" \
564 SNAME="${SNAME}" \
565 VERSION="${VERSION}" \
566 CORE="${CORE}" \
567 SLOGAN="${SLOGAN}" \
568 TOOLS_DIR="${TOOLS_DIR}" \
569 CONFIG_ROOT="${CONFIG_ROOT}" \
570 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
571 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 572 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
573 BUILDTARGET="${BUILDTARGET}" \
574 CROSSTARGET="${CROSSTARGET}" \
575 BUILD_ARCH="${BUILD_ARCH}" \
576 BUILD_PLATFORM="${BUILD_PLATFORM}" \
577 CCACHE_DIR=/usr/src/ccache \
578 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
579 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 580 GOCACHE="/usr/src/ccache/go" \
69a6ec55 581 KVER="${KVER}" \
0d7a6f03 582 XZ_OPT="${XZ_OPT}" \
77c863a2 583 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
584 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
585 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
586 $(fake_environ) \
587 $(qemu_environ) \
588 "$@"
589}
590
591entershell() {
592 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
593 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
594 fi
595
596 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 597 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
598
599 if enterchroot bash -i; then
600 stdumount
601 else
f9783277 602 print_status FAIL
69a6ec55
MT
603 exiterror "chroot error"
604 fi
605}
606
607lfsmakecommoncheck() {
608 # Script present?
609 if [ ! -f $BASEDIR/lfs/$1 ]; then
610 exiterror "No such file or directory: $BASEDIR/$1"
611 fi
612
f9783277
MT
613 # Print package name and version
614 print_package $@
69a6ec55
MT
615
616 # Check if this package is supported by our architecture.
617 # If no SUP_ARCH is found, we assume the package can be built for all.
618 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
619 # Check if package supports ${BUILD_ARCH} or all architectures.
620 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 621 print_runtime 0
f9783277 622 print_status SKIP
69a6ec55
MT
623 return 1
624 fi
625 fi
626
627 # Script slipped?
628 local i
629 for i in $SKIP_PACKAGE_LIST
630 do
631 if [ "$i" == "$1" ]; then
f9783277 632 print_status SKIP
69a6ec55
MT
633 return 1;
634 fi
635 done
636
637 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
638
639 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
640 MESSAGE="$1\t " download >> $LOGFILE 2>&1
641 if [ $? -ne 0 ]; then
642 exiterror "Download error in $1"
643 fi
644
645 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
646 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
647 if [ $? -ne 0 ]; then
648 exiterror "md5sum error in $1, check file in cache or signature"
649 fi
650
651 return 0 # pass all!
652}
653
654lfsmake1() {
655 lfsmakecommoncheck $*
656 [ $? == 1 ] && return 0
657
69a6ec55
MT
658 cd $BASEDIR/lfs && env -i \
659 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
660 CCACHE_DIR="${CCACHE_DIR}" \
661 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
662 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
663 CFLAGS="${CFLAGS}" \
664 CXXFLAGS="${CXXFLAGS}" \
77c863a2 665 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
666 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
667 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
668 make -f $* \
669 TOOLCHAIN=1 \
670 TOOLS_DIR="${TOOLS_DIR}" \
671 CROSSTARGET="${CROSSTARGET}" \
672 BUILDTARGET="${BUILDTARGET}" \
673 BUILD_ARCH="${BUILD_ARCH}" \
674 BUILD_PLATFORM="${BUILD_PLATFORM}" \
675 LFS_BASEDIR="${BASEDIR}" \
676 ROOT="${LFS}" \
677 KVER="${KVER}" \
f9783277 678 install >> $LOGFILE 2>&1 &
69a6ec55 679
f9783277
MT
680 if ! wait_until_finished $!; then
681 print_status FAIL
682 exiterror "Building $*"
69a6ec55
MT
683 fi
684
f9783277 685 print_status DONE
69a6ec55
MT
686}
687
688lfsmake2() {
689 lfsmakecommoncheck $*
690 [ $? == 1 ] && return 0
691
69a6ec55
MT
692 local PS1='\u:\w$ '
693
694 enterchroot \
ce9264a1 695 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
696 make -f $* \
697 LFS_BASEDIR=/usr/src install" \
f9783277 698 >> ${LOGFILE} 2>&1 &
69a6ec55 699
f9783277
MT
700 if ! wait_until_finished $!; then
701 print_status FAIL
702 exiterror "Building $*"
69a6ec55
MT
703 fi
704
f9783277 705 print_status DONE
69a6ec55
MT
706}
707
708ipfiredist() {
709 lfsmakecommoncheck $*
710 [ $? == 1 ] && return 0
711
69a6ec55
MT
712 local PS1='\u:\w$ '
713
714 enterchroot \
715 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 716 >> ${LOGFILE} 2>&1 &
69a6ec55 717
f9783277
MT
718 if ! wait_until_finished $!; then
719 print_status FAIL
720 exiterror "Packaging $*"
721 fi
69a6ec55 722
f9783277
MT
723 print_status DONE
724}
725
726wait_until_finished() {
727 local pid=${1}
728
729 local start_time=$(now)
730
731 # Show progress
732 if ${INTERACTIVE}; then
733 # Wait a little just in case the process
734 # has finished very quickly.
735 sleep 0.1
736
737 local runtime
738 while kill -0 ${pid} 2>/dev/null; do
739 print_runtime $(( $(now) - ${start_time} ))
740
741 # Wait a little
742 sleep 1
743 done
69a6ec55 744 fi
f9783277
MT
745
746 # Returns the exit code of the child process
747 wait ${pid}
748 local ret=$?
749
750 if ! ${INTERACTIVE}; then
751 print_runtime $(( $(now) - ${start_time} ))
752 fi
753
754 return ${ret}
69a6ec55
MT
755}
756
757fake_environ() {
758 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
759
760 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
761
762 # Fake kernel version, because some of the packages do not compile
763 # with kernel 3.0 and later.
8634797e 764 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
765
766 # Fake machine version.
767 env="${env} UTS_MACHINE=${BUILD_ARCH}"
768
769 echo "${env}"
770}
771
772qemu_environ() {
773 local env
774
775 # Don't add anything if qemu is not used.
776 if ! qemu_is_required; then
777 return
778 fi
779
780 # Set default qemu options
781 case "${BUILD_ARCH}" in
782 arm*)
783 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
784
785 env="${env} QEMU_CPU=${QEMU_CPU}"
786 ;;
787 esac
788
789 # Enable QEMU strace
790 #env="${env} QEMU_STRACE=1"
791
792 echo "${env}"
793}
794
795qemu_is_required() {
796 local build_arch="${1}"
797
798 if [ -z "${build_arch}" ]; then
799 build_arch="${BUILD_ARCH}"
800 fi
801
802 case "${HOST_ARCH},${build_arch}" in
803 x86_64,arm*|i?86,arm*|i?86,x86_64)
804 return 0
805 ;;
806 *)
807 return 1
808 ;;
809 esac
810}
811
812qemu_install_helper() {
813 # Do nothing, if qemu is not required
814 if ! qemu_is_required; then
815 return 0
816 fi
817
818 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
819 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
820 fi
821
822 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
823 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
824 fi
825
826
827 if [ -z "${QEMU_TARGET_HELPER}" ]; then
828 exiterror "QEMU_TARGET_HELPER not set"
829 fi
830
831 # Check if the helper is already installed.
832 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
833 return 0
834 fi
835
836 # Try to find a suitable binary that we can install
837 # to the build environment.
838 local file
839 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
840 # file must exist and be executable.
841 [ -x "${file}" ] || continue
842
843 # Must be static.
844 file_is_static "${file}" || continue
845
846 local dirname="${LFS}$(dirname "${file}")"
847 mkdir -p "${dirname}"
848
849 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
850 return 0
851 done
852
853 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
854}
855
856qemu_find_build_helper_name() {
857 local build_arch="${1}"
858
859 local magic
860 case "${build_arch}" in
861 arm*)
862 magic="7f454c4601010100000000000000000002002800"
863 ;;
864 x86_64)
865 magic="7f454c4602010100000000000000000002003e00"
866 ;;
867 esac
868
869 [ -z "${magic}" ] && return 1
870
871 local file
872 for file in /proc/sys/fs/binfmt_misc/*; do
873 # skip write only register entry
874 [ $(basename "${file}") = "register" ] && continue
875 # Search for the file with the correct magic value.
876 grep -qE "^magic ${magic}$" "${file}" || continue
877
878 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
879
880 [ -n "${interpreter}" ] || continue
881 [ "${interpreter:0:1}" = "/" ] || continue
882 [ -x "${interpreter}" ] || continue
883
884 echo "${interpreter}"
885 return 0
886 done
887
888 return 1
889}
890
891file_is_static() {
892 local file="${1}"
893
894 file ${file} 2>/dev/null | grep -q "statically linked"
895}
896
897update_language_list() {
898 local path="${1}"
899
900 local lang
901 for lang in ${path}/*.po; do
902 lang="$(basename "${lang}")"
903 echo "${lang%*.po}"
904 done | sort -u > "${path}/LINGUAS"
905}
906
1fb7f56e
MT
907contributors() {
908 local commits name
909
910 git shortlog --summary --numbered | while read -r commits name; do
911 echo "${name}"
912 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
913}
914
915update_contributors() {
916 echo -n "Updating list of contributors"
917
918 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
919
920 # Edit contributors into credits.cgi
e2338aa7
MT
921 local tmp="$(mktemp)"
922
923 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
924 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
925
926 # Copy back modified content
927 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
928 unlink "${tmp}"
1fb7f56e
MT
929
930 print_status DONE
931 return 0
932}
933
15b005d8 934# Default settings
99597de7 935CCACHE_CACHE_SIZE="4G"
15b005d8
MT
936ENABLE_RAMDISK="auto"
937
a98ab1d7
MT
938# Load configuration file
939if [ -f .config ]; then
940 . .config
941fi
942
813659f2
MT
943# TARGET_ARCH is BUILD_ARCH now
944if [ -n "${TARGET_ARCH}" ]; then
945 BUILD_ARCH="${TARGET_ARCH}"
946 unset TARGET_ARCH
947fi
948
85560933
MT
949# Get some information about the host system
950SYSTEM_PROCESSORS="$(system_processors)"
951SYSTEM_MEMORY="$(system_memory)"
952
dc7d6b20
MT
953if [ -n "${BUILD_ARCH}" ]; then
954 configure_build "${BUILD_ARCH}"
949544f5 955else
dc7d6b20 956 configure_build "default"
949544f5
MT
957fi
958
15b005d8
MT
959# Automatically enable/disable ramdisk usage
960if [ "${ENABLE_RAMDISK}" = "auto" ]; then
961 # Enable only when the host system has 4GB of RAM or more
962 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
963 ENABLE_RAMDISK="on"
964 fi
965fi
966
df5e82b3 967buildtoolchain() {
69a6ec55
MT
968 local error=false
969 case "${BUILD_ARCH}:${HOST_ARCH}" in
970 # x86_64
971 x86_64:x86_64)
972 # This is working.
973 ;;
974
975 # x86
976 i586:i586|i586:i686|i586:x86_64)
977 # These are working.
978 ;;
979 i586:*)
980 error=true
981 ;;
982
983 # ARM
984 arvm7hl:armv7hl|armv7hl:armv7l)
985 # These are working.
986 ;;
987
988 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
989 # These are working.
990 ;;
991 armv5tel:*)
992 error=true
993 ;;
994 esac
995
996 ${error} && \
997 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
998
999 local gcc=$(type -p gcc)
1000 if [ -z "${gcc}" ]; then
1001 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1002 fi
1003
6bd3a131
MT
1004 # Check ${TOOLS_DIR} symlink
1005 if [ -h "${TOOLS_DIR}" ]; then
1006 rm -f "${TOOLS_DIR}"
1007 fi
1008
1009 if [ ! -e "${TOOLS_DIR}" ]; then
1010 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1011 fi
1012
1013 if [ ! -h "${TOOLS_DIR}" ]; then
1014 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1015 fi
1016
ebaecf2c 1017 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1018 export LOGFILE
1019
1020 lfsmake1 stage1
1021 lfsmake1 ccache PASS=1
1022 lfsmake1 binutils PASS=1
1023 lfsmake1 gcc PASS=1
1024 lfsmake1 linux KCFG="-headers"
1025 lfsmake1 glibc
1026 lfsmake1 gcc PASS=L
1027 lfsmake1 binutils PASS=2
1028 lfsmake1 gcc PASS=2
54d54148 1029 lfsmake1 zlib
69a6ec55
MT
1030 lfsmake1 ccache PASS=2
1031 lfsmake1 tcl
1032 lfsmake1 expect
1033 lfsmake1 dejagnu
1034 lfsmake1 pkg-config
1035 lfsmake1 ncurses
1036 lfsmake1 bash
1037 lfsmake1 bzip2
1038 lfsmake1 automake
1039 lfsmake1 coreutils
1040 lfsmake1 diffutils
1041 lfsmake1 findutils
1042 lfsmake1 gawk
1043 lfsmake1 gettext
1044 lfsmake1 grep
1045 lfsmake1 gzip
1046 lfsmake1 m4
1047 lfsmake1 make
1048 lfsmake1 patch
1049 lfsmake1 perl
46bbc13b 1050 lfsmake1 python3
69a6ec55
MT
1051 lfsmake1 sed
1052 lfsmake1 tar
1053 lfsmake1 texinfo
1054 lfsmake1 xz
85439ac7 1055 lfsmake1 bison
11b5e5cb 1056 lfsmake1 flex
69a6ec55 1057 lfsmake1 fake-environ
7b93b62b 1058 lfsmake1 strip
69a6ec55 1059 lfsmake1 cleanup-toolchain
df5e82b3
MT
1060}
1061
1062buildbase() {
ebaecf2c 1063 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1064 export LOGFILE
1065 lfsmake2 stage2
1066 lfsmake2 linux KCFG="-headers"
1067 lfsmake2 man-pages
1068 lfsmake2 glibc
1069 lfsmake2 tzdata
1070 lfsmake2 cleanup-toolchain
1071 lfsmake2 zlib
1072 lfsmake2 binutils
1073 lfsmake2 gmp
1074 lfsmake2 gmp-compat
1075 lfsmake2 mpfr
1076 lfsmake2 libmpc
1077 lfsmake2 file
1078 lfsmake2 gcc
1079 lfsmake2 sed
1080 lfsmake2 autoconf
1081 lfsmake2 automake
1082 lfsmake2 berkeley
1083 lfsmake2 coreutils
1084 lfsmake2 iana-etc
1085 lfsmake2 m4
1086 lfsmake2 bison
69a6ec55
MT
1087 lfsmake2 ncurses
1088 lfsmake2 procps
1089 lfsmake2 libtool
1090 lfsmake2 perl
1091 lfsmake2 readline
1092 lfsmake2 readline-compat
1093 lfsmake2 bzip2
3ece7859 1094 lfsmake2 xz
69a6ec55
MT
1095 lfsmake2 pcre
1096 lfsmake2 pcre-compat
1097 lfsmake2 bash
1098 lfsmake2 diffutils
1099 lfsmake2 e2fsprogs
1100 lfsmake2 ed
1101 lfsmake2 findutils
1102 lfsmake2 flex
1103 lfsmake2 gawk
1104 lfsmake2 gettext
1105 lfsmake2 grep
1106 lfsmake2 groff
1107 lfsmake2 gperf
1108 lfsmake2 gzip
1109 lfsmake2 hostname
1110 lfsmake2 iproute2
1111 lfsmake2 jwhois
1112 lfsmake2 kbd
1113 lfsmake2 less
4720fa0d 1114 lfsmake2 pkg-config
69a6ec55
MT
1115 lfsmake2 make
1116 lfsmake2 man
69a6ec55
MT
1117 lfsmake2 net-tools
1118 lfsmake2 patch
1119 lfsmake2 psmisc
1120 lfsmake2 shadow
1121 lfsmake2 sysklogd
1122 lfsmake2 sysvinit
1123 lfsmake2 tar
1124 lfsmake2 texinfo
1125 lfsmake2 util-linux
69a6ec55 1126 lfsmake2 vim
df5e82b3
MT
1127}
1128
15679d9f 1129buildipfire() {
ebaecf2c 1130 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1131 export LOGFILE
489145db
MT
1132 lfsmake2 configroot
1133 lfsmake2 initscripts
1134 lfsmake2 backup
c38f55fe
MT
1135 lfsmake2 openssl
1136 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1ece41ec 1137 lfsmake2 kmod
e1c6cd05 1138 lfsmake2 udev
3755e358 1139 lfsmake2 popt
d4767896 1140 lfsmake2 libedit
489145db
MT
1141 lfsmake2 libusb
1142 lfsmake2 libusb-compat
1143 lfsmake2 libpcap
1144 lfsmake2 ppp
1145 lfsmake2 pptp
1146 lfsmake2 unzip
1147 lfsmake2 which
1148 lfsmake2 linux-firmware
489145db 1149 lfsmake2 dvb-firmwares
37b86fa9 1150 lfsmake2 xr819-firmware
489145db
MT
1151 lfsmake2 zd1211-firmware
1152 lfsmake2 rpi-firmware
26796f3a 1153 lfsmake2 intel-microcode
0e54ca26 1154 lfsmake2 pcengines-apu-firmware
489145db 1155 lfsmake2 bc
2a0947f2 1156 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1157 lfsmake2 cpio
1158 lfsmake2 mdadm
1159 lfsmake2 dracut
de18b4de 1160 lfsmake2 libaio
489145db
MT
1161 lfsmake2 lvm2
1162 lfsmake2 multipath-tools
1163 lfsmake2 freetype
489145db
MT
1164 lfsmake2 libmnl
1165 lfsmake2 libnfnetlink
1166 lfsmake2 libnetfilter_queue
1167 lfsmake2 libnetfilter_conntrack
1168 lfsmake2 libnetfilter_cthelper
1169 lfsmake2 libnetfilter_cttimeout
1170 lfsmake2 iptables
0245f3b6 1171 lfsmake2 screen
54ead8ef 1172 lfsmake2 elfutils
8e6fb99d 1173
dc7d6b20 1174 case "${BUILD_ARCH}" in
68a36e26 1175 x86_64|aarch64)
489145db 1176 lfsmake2 linux KCFG=""
b389d731
AF
1177# lfsmake2 backports KCFG=""
1178# lfsmake2 e1000e KCFG=""
1179# lfsmake2 igb KCFG=""
1180# lfsmake2 ixgbe KCFG=""
489145db
MT
1181 lfsmake2 xtables-addons KCFG=""
1182 lfsmake2 linux-initrd KCFG=""
fc155193 1183 ;;
3d02c091
MT
1184 i586)
1185 # x86-pae (Native and new XEN) kernel build
489145db 1186 lfsmake2 linux KCFG="-pae"
b389d731
AF
1187# lfsmake2 backports KCFG="-pae"
1188# lfsmake2 e1000e KCFG="-pae"
1189# lfsmake2 igb KCFG="-pae"
1190# lfsmake2 ixgbe KCFG="-pae"
489145db
MT
1191 lfsmake2 xtables-addons KCFG="-pae"
1192 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1193
1194 # x86 kernel build
489145db 1195 lfsmake2 linux KCFG=""
b389d731
AF
1196# lfsmake2 backports KCFG=""
1197# lfsmake2 e1000e KCFG=""
1198# lfsmake2 igb KCFG=""
1199# lfsmake2 ixgbe KCFG=""
489145db
MT
1200 lfsmake2 xtables-addons KCFG=""
1201 lfsmake2 linux-initrd KCFG=""
3d02c091 1202 ;;
544f40d4 1203
3d02c091 1204 armv5tel)
3d02c091 1205 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1206 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1207# lfsmake2 backports KCFG="-multi"
1208# lfsmake2 e1000e KCFG="-multi"
1209# lfsmake2 igb KCFG="-multi"
1210# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1211 lfsmake2 xtables-addons KCFG="-multi"
1212 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1213 ;;
1214 esac
489145db 1215 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1216 lfsmake2 libgpg-error
1217 lfsmake2 libgcrypt
1218 lfsmake2 libassuan
1219 lfsmake2 nettle
1a7db134 1220 lfsmake2 json-c
f3e62301 1221 lfsmake2 libconfig
489145db
MT
1222 lfsmake2 libevent
1223 lfsmake2 libevent2
1224 lfsmake2 expat
c8e9a7a8
WA
1225 lfsmake2 apr
1226 lfsmake2 aprutil
489145db
MT
1227 lfsmake2 unbound
1228 lfsmake2 gnutls
1229 lfsmake2 bind
1230 lfsmake2 dhcp
1231 lfsmake2 dhcpcd
1232 lfsmake2 boost
1233 lfsmake2 linux-atm
1234 lfsmake2 gdbm
1235 lfsmake2 pam
1236 lfsmake2 curl
1237 lfsmake2 tcl
1238 lfsmake2 sqlite
1239 lfsmake2 libffi
1240 lfsmake2 python
1241 lfsmake2 python3
b3ce3510
MT
1242 lfsmake2 grub
1243 lfsmake2 efivar
1244 lfsmake2 efibootmgr
489145db
MT
1245 lfsmake2 ca-certificates
1246 lfsmake2 fireinfo
1247 lfsmake2 libnet
1248 lfsmake2 libnl
1249 lfsmake2 libnl-3
1250 lfsmake2 libidn
1251 lfsmake2 nasm
1252 lfsmake2 libjpeg
1253 lfsmake2 libjpeg-compat
1254 lfsmake2 libexif
1255 lfsmake2 libpng
1256 lfsmake2 libtiff
1257 lfsmake2 libart
1258 lfsmake2 gd
489145db
MT
1259 lfsmake2 slang
1260 lfsmake2 newt
1261 lfsmake2 libsmooth
1262 lfsmake2 attr
1263 lfsmake2 acl
1264 lfsmake2 libcap
b051eb68 1265 lfsmake2 libcap-ng
489145db
MT
1266 lfsmake2 pciutils
1267 lfsmake2 usbutils
1268 lfsmake2 libxml2
1269 lfsmake2 libxslt
1270 lfsmake2 BerkeleyDB
489145db
MT
1271 lfsmake2 cyrus-sasl
1272 lfsmake2 openldap
1273 lfsmake2 apache2
489145db
MT
1274 lfsmake2 web-user-interface
1275 lfsmake2 flag-icons
1276 lfsmake2 jquery
6033b271 1277 lfsmake2 bootstrap
489145db
MT
1278 lfsmake2 arping
1279 lfsmake2 beep
78dd680d
MT
1280 lfsmake2 libarchive
1281 lfsmake2 cmake
1df47cc9 1282 lfsmake2 libssh
8a960584 1283 lfsmake2 cdrkit
489145db
MT
1284 lfsmake2 dosfstools
1285 lfsmake2 reiserfsprogs
1286 lfsmake2 xfsprogs
1287 lfsmake2 sysfsutils
1288 lfsmake2 fuse
1289 lfsmake2 ntfs-3g
1290 lfsmake2 ethtool
489145db
MT
1291 lfsmake2 fcron
1292 lfsmake2 perl-GD
1293 lfsmake2 GD-Graph
1294 lfsmake2 GD-TextUtil
1295 lfsmake2 perl-Device-SerialPort
1296 lfsmake2 perl-Device-Modem
1297 lfsmake2 perl-Apache-Htpasswd
1298 lfsmake2 gnupg
1299 lfsmake2 hdparm
1300 lfsmake2 sdparm
1301 lfsmake2 mtools
1302 lfsmake2 whatmask
1303 lfsmake2 conntrack-tools
1304 lfsmake2 libupnp
1305 lfsmake2 ipaddr
1306 lfsmake2 iputils
1307 lfsmake2 l7-protocols
489145db
MT
1308 lfsmake2 hwdata
1309 lfsmake2 logrotate
1310 lfsmake2 logwatch
1311 lfsmake2 misc-progs
1312 lfsmake2 nano
1313 lfsmake2 URI
294aa009
AF
1314 lfsmake2 perl-CGI
1315 lfsmake2 perl-Switch
489145db
MT
1316 lfsmake2 HTML-Tagset
1317 lfsmake2 HTML-Parser
1318 lfsmake2 HTML-Template
1319 lfsmake2 Compress-Zlib
1320 lfsmake2 Digest
1321 lfsmake2 Digest-SHA1
1322 lfsmake2 Digest-HMAC
1323 lfsmake2 libwww-perl
1324 lfsmake2 Net-DNS
1325 lfsmake2 Net-IPv4Addr
1326 lfsmake2 Net_SSLeay
1327 lfsmake2 IO-Stringy
1328 lfsmake2 IO-Socket-SSL
1329 lfsmake2 Unix-Syslog
1330 lfsmake2 Mail-Tools
1331 lfsmake2 MIME-Tools
1332 lfsmake2 Net-Server
1333 lfsmake2 Convert-TNEF
1334 lfsmake2 Convert-UUlib
1335 lfsmake2 Archive-Tar
1336 lfsmake2 Archive-Zip
1337 lfsmake2 Text-Tabs+Wrap
1338 lfsmake2 Locale-Country
1339 lfsmake2 XML-Parser
1340 lfsmake2 Crypt-PasswdMD5
1341 lfsmake2 Net-Telnet
1342 lfsmake2 python-setuptools
1343 lfsmake2 python-clientform
1344 lfsmake2 python-mechanize
1345 lfsmake2 python-feedparser
1346 lfsmake2 python-rssdler
1347 lfsmake2 python-inotify
1348 lfsmake2 python-docutils
1349 lfsmake2 python-daemon
1350 lfsmake2 python-ipaddress
1351 lfsmake2 glib
f107bb39 1352 lfsmake2 GeoIP
eba8e481 1353 lfsmake2 geoip-database
489145db
MT
1354 lfsmake2 ntp
1355 lfsmake2 openssh
1356 lfsmake2 fontconfig
1357 lfsmake2 dejavu-fonts-ttf
70f6cba4 1358 lfsmake2 ubuntu-font-family
489145db
MT
1359 lfsmake2 freefont
1360 lfsmake2 pixman
1361 lfsmake2 cairo
1362 lfsmake2 pango
1363 lfsmake2 rrdtool
489145db
MT
1364 lfsmake2 setup
1365 lfsmake2 libdnet
59fe9735 1366 lfsmake2 rust
616395f3 1367 lfsmake2 jansson
91cc908f 1368 lfsmake2 yaml
3498300d 1369 lfsmake2 libhtp
1a5f0649 1370 lfsmake2 colm
2348cfff 1371 lfsmake2 ragel
52ebc66b 1372 lfsmake2 hyperscan
67752a95 1373 lfsmake2 suricata
489145db 1374 lfsmake2 oinkmaster
ef640882 1375 lfsmake2 ids-ruleset-sources
489145db
MT
1376 lfsmake2 squid
1377 lfsmake2 squidguard
1378 lfsmake2 calamaris
1379 lfsmake2 tcpdump
1380 lfsmake2 traceroute
1381 lfsmake2 vlan
1382 lfsmake2 wireless
1383 lfsmake2 pakfire
1384 lfsmake2 spandsp
adf3f4f4 1385 lfsmake2 lz4
489145db
MT
1386 lfsmake2 lzo
1387 lfsmake2 openvpn
489145db
MT
1388 lfsmake2 mpage
1389 lfsmake2 dbus
1390 lfsmake2 intltool
1391 lfsmake2 libdaemon
6064cd87 1392 lfsmake2 avahi
489145db 1393 lfsmake2 cups
489145db 1394 lfsmake2 lcms2
56170c2a 1395 lfsmake2 ghostscript
489145db
MT
1396 lfsmake2 qpdf
1397 lfsmake2 poppler
1398 lfsmake2 cups-filters
1399 lfsmake2 epson-inkjet-printer-escpr
1400 lfsmake2 foomatic
1401 lfsmake2 hplip
1402 lfsmake2 cifs-utils
1403 lfsmake2 krb5
1404 lfsmake2 samba
1405 lfsmake2 sudo
1406 lfsmake2 mc
1407 lfsmake2 wget
1408 lfsmake2 bridge-utils
489145db
MT
1409 lfsmake2 smartmontools
1410 lfsmake2 htop
1411 lfsmake2 chkconfig
1412 lfsmake2 postfix
1413 lfsmake2 fetchmail
489145db 1414 lfsmake2 clamav
294aa009 1415 lfsmake2 perl-NetAddr-IP
489145db 1416 lfsmake2 spamassassin
438edc64 1417 lfsmake2 perl-Net-LibIDN
489145db
MT
1418 lfsmake2 amavisd
1419 lfsmake2 dma
1420 lfsmake2 alsa
1421 lfsmake2 mpfire
1422 lfsmake2 guardian
1423 lfsmake2 libid3tag
1424 lfsmake2 libmad
1425 lfsmake2 libogg
1426 lfsmake2 libvorbis
1427 lfsmake2 libdvbpsi
1428 lfsmake2 flac
1429 lfsmake2 lame
1430 lfsmake2 sox
41f8d642 1431 lfsmake2 soxr
489145db
MT
1432 lfsmake2 libshout
1433 lfsmake2 xvid
1434 lfsmake2 libmpeg2
489145db
MT
1435 lfsmake2 gnump3d
1436 lfsmake2 rsync
489145db
MT
1437 lfsmake2 libtirpc
1438 lfsmake2 rpcbind
14fb55a5 1439 lfsmake2 keyutils
489145db
MT
1440 lfsmake2 nfs
1441 lfsmake2 gnu-netcat
1442 lfsmake2 ncat
1443 lfsmake2 nmap
489145db
MT
1444 lfsmake2 etherwake
1445 lfsmake2 bwm-ng
1446 lfsmake2 sysstat
489145db
MT
1447 lfsmake2 strongswan
1448 lfsmake2 rng-tools
1449 lfsmake2 lsof
1450 lfsmake2 br2684ctl
1451 lfsmake2 pcmciautils
1452 lfsmake2 lm_sensors
1453 lfsmake2 liboping
1454 lfsmake2 collectd
1455 lfsmake2 elinks
1456 lfsmake2 igmpproxy
1457 lfsmake2 fbset
1458 lfsmake2 opus
1459 lfsmake2 python-six
1460 lfsmake2 python-pyparsing
1461 lfsmake2 spice-protocol
1462 lfsmake2 spice
1463 lfsmake2 sdl
1464 lfsmake2 libusbredir
43c3a386 1465 lfsmake2 libseccomp
489145db
MT
1466 lfsmake2 qemu
1467 lfsmake2 sane
1468 lfsmake2 netpbm
489145db 1469 lfsmake2 netsnmpd
489145db 1470 lfsmake2 nagios_nrpe
2af354c2 1471 lfsmake2 nagios-plugins
489145db 1472 lfsmake2 icinga
01c2ea6b 1473 lfsmake2 observium-agent
489145db 1474 lfsmake2 ebtables
489145db 1475 lfsmake2 faad2
e91ceed6 1476 lfsmake2 alac
489145db
MT
1477 lfsmake2 ffmpeg
1478 lfsmake2 vdr
1479 lfsmake2 vdr_streamdev
489145db
MT
1480 lfsmake2 vdr_epgsearch
1481 lfsmake2 vdr_dvbapi
1482 lfsmake2 vdr_eepg
1483 lfsmake2 w_scan
489145db
MT
1484 lfsmake2 mpd
1485 lfsmake2 libmpdclient
1486 lfsmake2 mpc
985741db 1487 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1488 lfsmake2 perl-Net-SMTP-SSL
1489 lfsmake2 perl-MIME-Base64
1490 lfsmake2 perl-Authen-SASL
1491 lfsmake2 perl-MIME-Lite
1492 lfsmake2 perl-Email-Date-Format
1493 lfsmake2 git
1494 lfsmake2 squidclamav
1495 lfsmake2 vnstat
1496 lfsmake2 iw
1497 lfsmake2 wpa_supplicant
1498 lfsmake2 hostapd
1499 lfsmake2 pycurl
1500 lfsmake2 urlgrabber
1501 lfsmake2 syslinux
1502 lfsmake2 tftpd
1503 lfsmake2 cpufrequtils
489145db
MT
1504 lfsmake2 gutenprint
1505 lfsmake2 apcupsd
1506 lfsmake2 iperf
1507 lfsmake2 iperf3
1508 lfsmake2 7zip
1509 lfsmake2 lynis
489145db
MT
1510 lfsmake2 sshfs
1511 lfsmake2 taglib
489145db
MT
1512 lfsmake2 sslh
1513 lfsmake2 perl-gettext
1514 lfsmake2 perl-Sort-Naturally
1515 lfsmake2 vdradmin
489145db 1516 lfsmake2 perl-DBI
489145db
MT
1517 lfsmake2 perl-DBD-SQLite
1518 lfsmake2 perl-File-ReadBackwards
489145db 1519 lfsmake2 openvmtools
489145db
MT
1520 lfsmake2 motion
1521 lfsmake2 joe
1522 lfsmake2 monit
1523 lfsmake2 nut
1524 lfsmake2 watchdog
1525 lfsmake2 libpri
1526 lfsmake2 libsrtp
1527 lfsmake2 asterisk
489145db
MT
1528 lfsmake2 usb_modeswitch
1529 lfsmake2 usb_modeswitch_data
1530 lfsmake2 zerofree
489145db
MT
1531 lfsmake2 minicom
1532 lfsmake2 ddrescue
489145db
MT
1533 lfsmake2 miniupnpd
1534 lfsmake2 client175
1535 lfsmake2 powertop
1536 lfsmake2 parted
1537 lfsmake2 swig
2a0947f2 1538 lfsmake2 u-boot
6836e528 1539 lfsmake2 u-boot-friendlyarm
5c82a9f0 1540 lfsmake2 python-typing
489145db
MT
1541 lfsmake2 python-m2crypto
1542 lfsmake2 wireless-regdb
1543 lfsmake2 crda
1544 lfsmake2 libsolv
1545 lfsmake2 python-distutils-extra
1546 lfsmake2 python-lzma
1547 lfsmake2 python-progressbar
1548 lfsmake2 python-xattr
1549 lfsmake2 ddns
2d17377a 1550 lfsmake2 python3-setuptools
662b2a81 1551 lfsmake2 python3-setuptools-scm
9e25fe5c 1552 lfsmake2 python3-six
e0a05a80 1553 lfsmake2 python3-dateutil
d48ea6b5 1554 lfsmake2 python3-jmespath
a33ca4cc 1555 lfsmake2 python3-colorama
041d2116 1556 lfsmake2 python3-docutils
d2da17a1 1557 lfsmake2 python3-yaml
953f6f73 1558 lfsmake2 python3-s3transfer
d45d5247 1559 lfsmake2 python3-rsa
faa5472a 1560 lfsmake2 python3-pyasn1
4ab80c5d 1561 lfsmake2 python3-botocore
3be81987 1562 lfsmake2 python3-llfuse
def9f4a3 1563 lfsmake2 python3-msgpack
280ee7e7 1564 lfsmake2 aws-cli
489145db
MT
1565 lfsmake2 transmission
1566 lfsmake2 dpfhack
1567 lfsmake2 lcd4linux
1568 lfsmake2 mtr
489145db
MT
1569 lfsmake2 minidlna
1570 lfsmake2 acpid
1571 lfsmake2 fping
1572 lfsmake2 telnet
1573 lfsmake2 xinetd
1574 lfsmake2 gpgme
1575 lfsmake2 pygpgme
1576 lfsmake2 pakfire3
1577 lfsmake2 stress
1578 lfsmake2 libstatgrab
1579 lfsmake2 sarg
489145db
MT
1580 lfsmake2 nginx
1581 lfsmake2 sendEmail
1582 lfsmake2 sysbench
1583 lfsmake2 strace
489145db
MT
1584 lfsmake2 ltrace
1585 lfsmake2 ipfire-netboot
1586 lfsmake2 lcdproc
489145db
MT
1587 lfsmake2 keepalived
1588 lfsmake2 ipvsadm
1589 lfsmake2 perl-Carp-Clan
1590 lfsmake2 perl-Date-Calc
1591 lfsmake2 perl-Date-Manip
1592 lfsmake2 perl-File-Tail
1593 lfsmake2 perl-TimeDate
1594 lfsmake2 swatch
1595 lfsmake2 tor
489145db
MT
1596 lfsmake2 wavemon
1597 lfsmake2 iptraf-ng
1598 lfsmake2 iotop
1599 lfsmake2 stunnel
489145db 1600 lfsmake2 bacula
b62c826f
MT
1601 lfsmake2 perl-Font-TTF
1602 lfsmake2 perl-IO-String
489145db
MT
1603 lfsmake2 perl-PDF-API2
1604 lfsmake2 squid-accounting
1605 lfsmake2 pigz
1606 lfsmake2 tmux
1607 lfsmake2 perl-Text-CSV_XS
09b09b85 1608 lfsmake2 lua
489145db
MT
1609 lfsmake2 haproxy
1610 lfsmake2 ipset
489145db
MT
1611 lfsmake2 dnsdist
1612 lfsmake2 bird
1a7db134 1613 lfsmake2 frr
489145db
MT
1614 lfsmake2 dmidecode
1615 lfsmake2 mcelog
489145db
MT
1616 lfsmake2 util-macros
1617 lfsmake2 libpciaccess
1618 lfsmake2 libyajl
1619 lfsmake2 libvirt
1620 lfsmake2 freeradius
1621 lfsmake2 perl-common-sense
1622 lfsmake2 perl-inotify2
1623 lfsmake2 perl-Net-IP
0d6cc79d 1624 lfsmake2 wio
773caa66 1625 lfsmake2 iftop
ddcd60f7 1626 lfsmake2 mdns-repeater
429af178 1627 lfsmake2 i2c-tools
4e9000b4 1628 lfsmake2 nss-myhostname
014b235a 1629 lfsmake2 dehydrated
c708fa15 1630 lfsmake2 shairport-sync
46114d79 1631 lfsmake2 borgbackup
2397e513 1632 lfsmake2 knot
e1982c69 1633 lfsmake2 spectre-meltdown-checker
06fc6170 1634 lfsmake2 zabbix_agentd
82d176d3 1635 lfsmake2 flashrom
2aca6aa0 1636 lfsmake2 firmware-update
ffcef39d 1637 lfsmake2 tshark
392994dc 1638 lfsmake2 geoip-generator
9875e9f2 1639 lfsmake2 speedtest-cli
0db643ce 1640 lfsmake2 rfkill
44cc9a3d 1641 lfsmake2 amazon-ssm-agent
d0817963 1642}
df5e82b3
MT
1643
1644buildinstaller() {
1645 # Run installer scripts one by one
ebaecf2c 1646 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1647 export LOGFILE
489145db
MT
1648 lfsmake2 memtest
1649 lfsmake2 installer
ce9264a1
AF
1650 # use toolchain bash for chroot to strip
1651 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1652}
1653
1654buildpackages() {
ebaecf2c 1655 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1656 export LOGFILE
1657 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1658
df5e82b3
MT
1659
1660 # Generating list of packages used
dc4ae0b7 1661 print_line "Generating packages list from logs"
df5e82b3 1662 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1663 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1664 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1665 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1666 fi
1667 done
7471f6ab 1668 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1669 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1670 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1671 rm -f $BASEDIR/doc/packages-list
c9673262 1672 # packages-list.txt is ready to be displayed for wiki page
f9783277 1673 print_status DONE
4b06f504
MT
1674
1675 # Update changelog
e49f7f0d 1676 cd $BASEDIR
c43b07fd
AF
1677 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1678 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1679 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1680
9607771a 1681 # Create images for install
489145db 1682 lfsmake2 cdrom
bada0832 1683
4dc82852 1684 # Check if there is a loop device for building in virtual environments
841663e7
MT
1685 modprobe loop 2>/dev/null
1686 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1687 lfsmake2 flash-images
4dc82852 1688 fi
c9673262 1689
c4dd9dfc 1690 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1691
0d909a4a 1692 ipfirepackages
e67a57fe 1693
489145db 1694 lfsmake2 xen-image
939c2a21 1695 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1696
b307417f 1697 cd $BASEDIR
744a04ea
AF
1698
1699 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1700 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1701
92244a40 1702 for i in `ls *.bz2 *.img.xz *.iso`; do
b307417f
AF
1703 md5sum $i > $i.md5
1704 done
1705 cd $PWD
1706
e67a57fe
MT
1707 # Cleanup
1708 stdumount
1709 rm -rf $BASEDIR/build/tmp/*
1710
e67a57fe 1711 cd $PWD
e67a57fe
MT
1712}
1713
1714ipfirepackages() {
489145db 1715 lfsmake2 core-updates
5596077b
MT
1716
1717 local i
dc7d6b20 1718 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1719 i=$(basename ${i})
453b418b
MT
1720 if [ -e $BASEDIR/lfs/$i ]; then
1721 ipfiredist $i
1722 else
1723 echo -n $i
f9783277 1724 print_status SKIP
453b418b 1725 fi
fe7fe395 1726 done
78331e30 1727 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1728 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1729 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1730}
1731
bcb9dc13
MT
1732while [ $# -gt 0 ]; do
1733 case "${1}" in
1734 --target=*)
c2e810de 1735 configure_build "${1#--target=}"
bcb9dc13
MT
1736 ;;
1737 -*)
1738 exiterror "Unknown configuration option: ${1}"
1739 ;;
1740 *)
1741 # Found a command, so exit options parsing.
1742 break
1743 ;;
1744 esac
1745 shift
1746done
1747
df5e82b3
MT
1748# See what we're supposed to do
1749case "$1" in
1750build)
f9783277
MT
1751 START_TIME=$(now)
1752
1753 # Clear screen
1754 ${INTERACTIVE} && clear
1755
f74072a2 1756 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1757 #only restore on a clean disk
6c4cc7ea 1758 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1759 if [ ! -n "$PACKAGE" ]; then
f9783277 1760 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1761 prepareenv
1762 buildtoolchain
1763 else
f74072a2 1764 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1765 print_build_stage "Packaged toolchain compilation"
df5e82b3 1766 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1767 tar axf $PACKAGE
df5e82b3
MT
1768 prepareenv
1769 else
1770 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1771 fi
1772 fi
1773 else
df5e82b3
MT
1774 prepareenv
1775 fi
5cfe86e6 1776
f9783277 1777 print_build_stage "Building LFS"
df5e82b3 1778 buildbase
15679d9f 1779
f9783277 1780 print_build_stage "Building IPFire"
15679d9f 1781 buildipfire
5cfe86e6 1782
f9783277 1783 print_build_stage "Building installer"
df5e82b3 1784 buildinstaller
15679d9f 1785
f9783277 1786 print_build_stage "Building packages"
df5e82b3 1787 buildpackages
7a5ed24e 1788
f9783277 1789 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1790
1791 cd $BASEDIR
7a5ed24e 1792 tools/checknewlog.pl
e0c923f4 1793 tools/checkrootfiles
b307417f 1794 cd $PWD
a23731d1 1795
f9783277 1796 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1797 ;;
1798shell)
1799 # enter a shell inside LFS chroot
1800 # may be used to changed kernel settings
1801 prepareenv
1802 entershell
1803 ;;
df5e82b3 1804clean)
f9783277
MT
1805 print_line "Cleaning build directory..."
1806
df5e82b3
MT
1807 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1808 $LOSETUP -d $i 2>/dev/null
1809 done
1810 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1811 umount $i
1812 done
1813 stdumount
1814 for i in `seq 0 7`; do
69a6ec55 1815 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1816 umount /dev/loop${i} 2>/dev/null;
1817 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1818 fi;
df5e82b3
MT
1819 done
1820 rm -rf $BASEDIR/build
1821 rm -rf $BASEDIR/cdrom
f9315063 1822 rm -rf $BASEDIR/packages
ebaecf2c 1823 rm -rf $BASEDIR/log
6c4cc7ea
MT
1824 if [ -h "${TOOLS_DIR}" ]; then
1825 rm -f "${TOOLS_DIR}"
df5e82b3 1826 fi
b307417f 1827 rm -f $BASEDIR/ipfire-*
f9783277 1828 print_status DONE
df5e82b3 1829 ;;
4e432799
MT
1830docker)
1831 # Build the docker image if it does not exist, yet
1832 if ! docker images -a | grep -q ^ipfire-builder; then
1833 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1834 print_status DONE
1835 else
1836 print_status FAIL
1837 exit 1
1838 fi
1839 fi
1840
1841 # Run the container and enter a shell
1842 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1843 ;;
c3db995c 1844downloadsrc)
df5e82b3
MT
1845 if [ ! -d $BASEDIR/cache ]; then
1846 mkdir $BASEDIR/cache
1847 fi
ebaecf2c 1848 mkdir -p $BASEDIR/log
857d9bf2 1849 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1850 FINISHED=0
1851 cd $BASEDIR/lfs
1852 for c in `seq $MAX_RETRIES`; do
1853 if (( FINISHED==1 )); then
1854 break
1855 fi
1856 FINISHED=1
1857 cd $BASEDIR/lfs
1858 for i in *; do
1859 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1860 lfsmakecommoncheck ${i} || continue
1861
dc7d6b20 1862 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1863 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1864 if [ $? -ne 0 ]; then
f9783277 1865 print_status FAIL
df5e82b3
MT
1866 FINISHED=0
1867 else
1868 if [ $c -eq 1 ]; then
f9783277 1869 print_status DONE
df5e82b3
MT
1870 fi
1871 fi
1872 fi
1873 done
1874 done
e22c7973 1875 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1876 ERROR=0
1877 for i in *; do
1878 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1879 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1880 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1881 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1882 if [ $? -ne 0 ]; then
e22c7973 1883 echo -ne "MD5 difference in lfs/$i"
f9783277 1884 print_status FAIL
df5e82b3
MT
1885 ERROR=1
1886 fi
1887 fi
1888 done
1889 if [ $ERROR -eq 0 ]; then
e22c7973 1890 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1891 print_status DONE
e22c7973
MT
1892 else
1893 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1894 print_status FAIL
df5e82b3 1895 fi
e22c7973 1896 cd - >/dev/null 2>&1
df5e82b3 1897 ;;
df5e82b3 1898toolchain)
f9783277
MT
1899 # Clear screen
1900 ${INTERACTIVE} && clear
1901
df5e82b3 1902 prepareenv
f3b7cf47 1903 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1904 buildtoolchain
f74072a2 1905 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1906 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1907 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1908 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1909 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1910 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1911 stdumount
1912 ;;
1913gettoolchain)
df5e82b3 1914 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1915 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1916 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1917 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1918 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1919 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1920 cd $BASEDIR/cache/toolchains
f74072a2 1921 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1922 if [ $? -ne 0 ]; then
dc7d6b20 1923 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1924 else
f74072a2 1925 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1926 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1927 else
1928 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1929 fi
40a4ea4c 1930 fi
712d859c
MT
1931 else
1932 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1933 fi
1934 ;;
15679d9f
MT
1935uploadsrc)
1936 PWD=`pwd`
661d9388
CS
1937 if [ -z $IPFIRE_USER ]; then
1938 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1939 print_status FAIL
661d9388
CS
1940 exit 1
1941 fi
ae23a606 1942
661d9388 1943 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1944 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1945
15e38431
MT
1946 for file in ${BASEDIR}/cache/*; do
1947 [ -d "${file}" ] && continue
1948 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1949 NEW_FILES="$NEW_FILES $file"
0eab8e84 1950 done
661d9388
CS
1951 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1952 cd $BASEDIR
15679d9f
MT
1953 cd $PWD
1954 exit 0
0eab8e84 1955 ;;
bf7c473f 1956lang)
69a6ec55
MT
1957 echo -ne "Checking the translations for missing or obsolete strings..."
1958 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1959 $BASEDIR/tools/sort_strings.pl en
1960 $BASEDIR/tools/sort_strings.pl de
1961 $BASEDIR/tools/sort_strings.pl fr
1962 $BASEDIR/tools/sort_strings.pl es
1963 $BASEDIR/tools/sort_strings.pl pl
1964 $BASEDIR/tools/sort_strings.pl ru
1965 $BASEDIR/tools/sort_strings.pl nl
1966 $BASEDIR/tools/sort_strings.pl tr
1967 $BASEDIR/tools/sort_strings.pl it
1968 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1969 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1970 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1971 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1972 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1973 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1974 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1975 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1976 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1977 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1978 print_status DONE
69a6ec55
MT
1979
1980 echo -ne "Updating language lists..."
1981 update_language_list ${BASEDIR}/src/installer/po
1982 update_language_list ${BASEDIR}/src/setup/po
f9783277 1983 print_status DONE
bf7c473f 1984 ;;
1fb7f56e
MT
1985update-contributors)
1986 update_contributors
1987 ;;
6b8cff41 1988*)
1fb7f56e 1989 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
6b8cff41
MT
1990 cat doc/make.sh-usage
1991 ;;
3ea75603 1992esac